/*
EntryPoints

## Overview  EntryPoint is one of the ways to start interaction flow. It can be represented as QR code, link (https://slace.me/... URL) or NFC tag.  ## Data  EntryPoints contain two types of data:   - **static** - *\"internal\" data storage which can be updated only via editing the EntryPoint* (directly or via Interaction) - **dynamic** - *public data which can be altered also via query parameters of the EP link. Should NOT be used for secrets or critical data* because it can be overwritten by the end user.  Both data containers are copied to transaction created when EntryPoint is entered. This data is used primarily for personalization or flow control of the Interaction.  ## EP Batches  EntryPoints can be batch-created (superadmin feature) and then [assigned](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx) to specific Interactions.  > EntryPoints in a batch have random hashes but it's possible to mass-create EPs using the assignment feature (only superadmins). If a value from **Link hash** column is not found it will be auto-created. This allows to create EntryPoints following different hash pattern (e.g. with common prefix).  EntryPoints are re-assignable meaning that they can be re-used for other Interactions even in another Channel or Organization by another [assignment import](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx).  ## Redirects  There is a special type of EntryPoint which does not start a SLACE Interaction but redirects to a configured URL.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package entrypoints

import (
	"encoding/json"
	"time"
)

// checks if the BatchesJob type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &BatchesJob{}

// BatchesJob struct for BatchesJob
type BatchesJob struct {
	Id *string `json:"id,omitempty"`
	OrderedBatchId *string `json:"ordered_batch_id,omitempty"`
	OrderedBatch map[string]interface{} `json:"ordered_batch,omitempty"`
	MediaId *string `json:"media_id,omitempty"`
	Type *string `json:"type,omitempty"`
	Status *string `json:"status,omitempty"`
	Progress *string `json:"progress,omitempty"`
	FailedReason *string `json:"failed_reason,omitempty"`
	BatchType *string `json:"batch_type,omitempty"`
	CreatedAt *time.Time `json:"created_at,omitempty"`
	UpdatedAt *time.Time `json:"updated_at,omitempty"`
}

// NewBatchesJob instantiates a new BatchesJob object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBatchesJob() *BatchesJob {
	this := BatchesJob{}
	return &this
}

// NewBatchesJobWithDefaults instantiates a new BatchesJob object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBatchesJobWithDefaults() *BatchesJob {
	this := BatchesJob{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *BatchesJob) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *BatchesJob) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *BatchesJob) SetId(v string) {
	o.Id = &v
}

// GetOrderedBatchId returns the OrderedBatchId field value if set, zero value otherwise.
func (o *BatchesJob) GetOrderedBatchId() string {
	if o == nil || IsNil(o.OrderedBatchId) {
		var ret string
		return ret
	}
	return *o.OrderedBatchId
}

// GetOrderedBatchIdOk returns a tuple with the OrderedBatchId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetOrderedBatchIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrderedBatchId) {
		return nil, false
	}
	return o.OrderedBatchId, true
}

// HasOrderedBatchId returns a boolean if a field has been set.
func (o *BatchesJob) HasOrderedBatchId() bool {
	if o != nil && !IsNil(o.OrderedBatchId) {
		return true
	}

	return false
}

// SetOrderedBatchId gets a reference to the given string and assigns it to the OrderedBatchId field.
func (o *BatchesJob) SetOrderedBatchId(v string) {
	o.OrderedBatchId = &v
}

// GetOrderedBatch returns the OrderedBatch field value if set, zero value otherwise.
func (o *BatchesJob) GetOrderedBatch() map[string]interface{} {
	if o == nil || IsNil(o.OrderedBatch) {
		var ret map[string]interface{}
		return ret
	}
	return o.OrderedBatch
}

// GetOrderedBatchOk returns a tuple with the OrderedBatch field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetOrderedBatchOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.OrderedBatch) {
		return map[string]interface{}{}, false
	}
	return o.OrderedBatch, true
}

// HasOrderedBatch returns a boolean if a field has been set.
func (o *BatchesJob) HasOrderedBatch() bool {
	if o != nil && !IsNil(o.OrderedBatch) {
		return true
	}

	return false
}

// SetOrderedBatch gets a reference to the given map[string]interface{} and assigns it to the OrderedBatch field.
func (o *BatchesJob) SetOrderedBatch(v map[string]interface{}) {
	o.OrderedBatch = v
}

// GetMediaId returns the MediaId field value if set, zero value otherwise.
func (o *BatchesJob) GetMediaId() string {
	if o == nil || IsNil(o.MediaId) {
		var ret string
		return ret
	}
	return *o.MediaId
}

// GetMediaIdOk returns a tuple with the MediaId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetMediaIdOk() (*string, bool) {
	if o == nil || IsNil(o.MediaId) {
		return nil, false
	}
	return o.MediaId, true
}

// HasMediaId returns a boolean if a field has been set.
func (o *BatchesJob) HasMediaId() bool {
	if o != nil && !IsNil(o.MediaId) {
		return true
	}

	return false
}

// SetMediaId gets a reference to the given string and assigns it to the MediaId field.
func (o *BatchesJob) SetMediaId(v string) {
	o.MediaId = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *BatchesJob) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *BatchesJob) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *BatchesJob) SetType(v string) {
	o.Type = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *BatchesJob) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *BatchesJob) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *BatchesJob) SetStatus(v string) {
	o.Status = &v
}

// GetProgress returns the Progress field value if set, zero value otherwise.
func (o *BatchesJob) GetProgress() string {
	if o == nil || IsNil(o.Progress) {
		var ret string
		return ret
	}
	return *o.Progress
}

// GetProgressOk returns a tuple with the Progress field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetProgressOk() (*string, bool) {
	if o == nil || IsNil(o.Progress) {
		return nil, false
	}
	return o.Progress, true
}

// HasProgress returns a boolean if a field has been set.
func (o *BatchesJob) HasProgress() bool {
	if o != nil && !IsNil(o.Progress) {
		return true
	}

	return false
}

// SetProgress gets a reference to the given string and assigns it to the Progress field.
func (o *BatchesJob) SetProgress(v string) {
	o.Progress = &v
}

// GetFailedReason returns the FailedReason field value if set, zero value otherwise.
func (o *BatchesJob) GetFailedReason() string {
	if o == nil || IsNil(o.FailedReason) {
		var ret string
		return ret
	}
	return *o.FailedReason
}

// GetFailedReasonOk returns a tuple with the FailedReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetFailedReasonOk() (*string, bool) {
	if o == nil || IsNil(o.FailedReason) {
		return nil, false
	}
	return o.FailedReason, true
}

// HasFailedReason returns a boolean if a field has been set.
func (o *BatchesJob) HasFailedReason() bool {
	if o != nil && !IsNil(o.FailedReason) {
		return true
	}

	return false
}

// SetFailedReason gets a reference to the given string and assigns it to the FailedReason field.
func (o *BatchesJob) SetFailedReason(v string) {
	o.FailedReason = &v
}

// GetBatchType returns the BatchType field value if set, zero value otherwise.
func (o *BatchesJob) GetBatchType() string {
	if o == nil || IsNil(o.BatchType) {
		var ret string
		return ret
	}
	return *o.BatchType
}

// GetBatchTypeOk returns a tuple with the BatchType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetBatchTypeOk() (*string, bool) {
	if o == nil || IsNil(o.BatchType) {
		return nil, false
	}
	return o.BatchType, true
}

// HasBatchType returns a boolean if a field has been set.
func (o *BatchesJob) HasBatchType() bool {
	if o != nil && !IsNil(o.BatchType) {
		return true
	}

	return false
}

// SetBatchType gets a reference to the given string and assigns it to the BatchType field.
func (o *BatchesJob) SetBatchType(v string) {
	o.BatchType = &v
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise.
func (o *BatchesJob) GetCreatedAt() time.Time {
	if o == nil || IsNil(o.CreatedAt) {
		var ret time.Time
		return ret
	}
	return *o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreatedAt) {
		return nil, false
	}
	return o.CreatedAt, true
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *BatchesJob) HasCreatedAt() bool {
	if o != nil && !IsNil(o.CreatedAt) {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given time.Time and assigns it to the CreatedAt field.
func (o *BatchesJob) SetCreatedAt(v time.Time) {
	o.CreatedAt = &v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *BatchesJob) GetUpdatedAt() time.Time {
	if o == nil || IsNil(o.UpdatedAt) {
		var ret time.Time
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BatchesJob) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.UpdatedAt) {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *BatchesJob) HasUpdatedAt() bool {
	if o != nil && !IsNil(o.UpdatedAt) {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given time.Time and assigns it to the UpdatedAt field.
func (o *BatchesJob) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = &v
}

func (o BatchesJob) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o BatchesJob) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.OrderedBatchId) {
		toSerialize["ordered_batch_id"] = o.OrderedBatchId
	}
	if !IsNil(o.OrderedBatch) {
		toSerialize["ordered_batch"] = o.OrderedBatch
	}
	if !IsNil(o.MediaId) {
		toSerialize["media_id"] = o.MediaId
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.Progress) {
		toSerialize["progress"] = o.Progress
	}
	if !IsNil(o.FailedReason) {
		toSerialize["failed_reason"] = o.FailedReason
	}
	if !IsNil(o.BatchType) {
		toSerialize["batch_type"] = o.BatchType
	}
	if !IsNil(o.CreatedAt) {
		toSerialize["created_at"] = o.CreatedAt
	}
	if !IsNil(o.UpdatedAt) {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	return toSerialize, nil
}

type NullableBatchesJob struct {
	value *BatchesJob
	isSet bool
}

func (v NullableBatchesJob) Get() *BatchesJob {
	return v.value
}

func (v *NullableBatchesJob) Set(val *BatchesJob) {
	v.value = val
	v.isSet = true
}

func (v NullableBatchesJob) IsSet() bool {
	return v.isSet
}

func (v *NullableBatchesJob) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBatchesJob(val *BatchesJob) *NullableBatchesJob {
	return &NullableBatchesJob{value: val, isSet: true}
}

func (v NullableBatchesJob) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBatchesJob) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


